"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const anchor = __importStar(require("@project-serum/anchor"));
const spl_token_bonding_1 = require("@strata-foundation/spl-token-bonding");
const spl_token_collective_1 = require("@strata-foundation/spl-token-collective");
function run() {
    return __awaiter(this, void 0, void 0, function* () {
        console.log(process.env.ANCHOR_PROVIDER_URL);
        anchor.setProvider(anchor.Provider.env());
        const provider = anchor.getProvider();
        const tokenBondingSdk = yield spl_token_bonding_1.SplTokenBonding.init(provider);
        const tokenCollectiveSdk = yield spl_token_collective_1.SplTokenCollective.init(provider);
        const collective = yield tokenCollectiveSdk.getCollective(spl_token_collective_1.SplTokenCollective.OPEN_COLLECTIVE_ID);
        // @ts-ignore
        const socialCurve = collective === null || collective === void 0 ? void 0 : collective.config.unclaimedTokenBondingSettings.curve;
        const curve0 = yield tokenBondingSdk.getCurve(socialCurve);
        yield tokenBondingSdk.rpc.patchCurve({
            accounts: {
                curve: socialCurve,
                strata: provider.wallet.publicKey
            }
        });
        const curve1 = yield tokenBondingSdk.getCurve(socialCurve);
        console.log(JSON.stringify(curve0, null, 2));
        console.log(JSON.stringify(curve1, null, 2));
    });
}
run().catch(e => {
    console.error(e);
    process.exit(1);
});
//# sourceMappingURL=patchCurve.js.map